<?php

use Automattic\WooCommerce\Internal\DataStores\Orders\CustomOrdersTableController;


class AdminMetabox {

    function getValue($key)
    {
        $ini_array = parse_ini_file("plugin.ini");
        $value =  $ini_array[$key];
        return $value;
    }

    function admin_order_custom_metabox() {
        $screen = class_exists( '\Automattic\WooCommerce\Internal\DataStores\Orders\CustomOrdersTableController' ) && 
        wc_get_container()->get( CustomOrdersTableController::class )->custom_orders_table_usage_is_enabled()
            ? wc_get_page_screen_id( 'shop-order' )
            : 'shop_order';
    
        add_meta_box(
            'custom',
            'Pakkepost',
            array($this,'custom_metabox_content'),
            $screen,
            'normal',
            'default'
        );
    }
    
    
    function add_meta_boxesws()
    {
        add_meta_box('custom_order_meta_box', __('Booking Shipment Section'), array($this,'custom_metabox_content'), 'wc-order', 'normal', 'default');
    }


    public function admin_order_display_pakkepost( $order ) {
        // Load settings and convert them in variables
        $frontend = new PakkepostFrontend();
        extract( $frontend->carrier_settings() );

        $pakkepostProduct = $order->get_meta( '_'.$field_id ); // Get Shipping product

        if( ! empty($pakkepostProduct) ) {
            echo '<p><strong>' . $label_name . '</strong>: ' . $pakkepostProduct . '</p>';
        }

        extract( $frontend->packages_settings() );
    
        $package = $order->get_meta( '_'.$package_id ); // Get packages
  
        if( ! empty($package) ) {
            // Display
            echo '<p><strong>' . 'Antall pakker:' . '</strong> ' . $package . '</p>';
        }
    
        $serviceLocation = $order->get_meta( '_service_location' ); 
  
        if( ! empty($serviceLocation) ) {
            // Display
            echo '<p><strong>' . 'Utleveringssted:' . '</strong> ' . $serviceLocation . '</p>';
        }
    }

    
    public function display_shipping_product_on_order_item_totals( $total_rows, $order, $tax_display ){
    
  
        // Load settings and convert them in variables
        $frontend = new PakkepostFrontend();
        extract( $frontend->carrier_settings() );
    
        $carrier = $order->get_meta( '_'.$field_id ); // Get Shipping product
    
        if( ! empty($carrier) ) {
            $new_total_rows = [];
    
            // Loop through order total rows
            foreach( $total_rows as $key => $values ) {
                $new_total_rows[$key] = $values;
                
                // Inserting the Shipping product under shipping method
                if( $key === 'shipping' ) {
                    $new_total_rows[$field_id] = array(
                        'label' => $label_name,
                        'value' => $carrier,
                    );
                }
            }
            return $new_total_rows;
        }
        return $total_rows;
    }
    
    public function display_packages_on_order_item_totals( $total_rows, $order, $tax_display ){

        // Load settings and convert them in variables
        $frontend = new PakkepostFrontend();
        extract( $frontend->packages_settings() );
    
        $package = $order->get_meta( '_'.$package_id ); // Get packages
    
        if( ! empty($package) ) {
            $new_total_rows = [];
    
            // Loop through order total rows
            foreach( $total_rows as $key => $values ) {
                $new_total_rows[$key] = $values;
                
                // Inserting the Shipping product under shipping method
                if( $key === 'shipping' ) {
                    $new_total_rows[$field_id] = array(
                        'label' => $label_name,
                        'value' => $carrier,
                    );
                }
            }
            return $new_total_rows;
        }
        return $total_rows;
    }


    function custom_metabox_content($object)
    {
        $order = is_a( $object, 'WP_Post' ) ? wc_get_order( $object->ID ) : $object;

        global $wpdb;

        ?>
        <div style="width:100%;">
            <select data-pakketinput="1" name="shipping_type[<?php echo (int)$order->ID; ?>]" id="shipping_type">
                <?php if (get_option('pakkepost_supplier') == 'Bring') { ?>
                <option value ="0"> - VELG - </option>
                <option value="153">Norge S - 35x22x10cm 1kg</option>
                <option value="2005">Norge M - 10kg</option>
                <option value="2006">Norge L - 20kg</option>
                <option value="2007">Norge XL - 35kg</option>
                <option value="2011">Bedrift S - 10kg</option>
                <option value="2013">Bedrift M - 35kg</option>

                <?php } else { ?>
                <option value ="0"> - VELG - </option>
                <option value="2038">Pakkeautomat - 50x30x20cm 5kg</option>
                <option value="2027">Medium - 5kg</option>
                <option value="2026">Stor - 10kg</option>
                <option value="2028">XL - 20kg</option>
                <option value="2029">XXL - 35 kg</option>
                <option value="2034">Bedrift Liten - 5kg</option>
                <option value="2036">Bedrift Medium - 15kg</option>
                <option value="2037">Bedrift Stor - 35kg</option>

                <?php } ?>
            </select>

            <select data-pakketinput="1" name="number_of_packages">
                <option value="1">1</option>
                <option value="2">2</option>
                <option value="3">3</option>
                <option value="4">4</option>
                <option value="5">5</option>
            </select>

            <a href="<?php echo(admin_url('admin-ajax.php?action=my_action_pakkepost')); ?>"
            id="book_shipment" class="button" target="_blank"
            onclick="return bookShipment(this, event, <?php echo (int)$order->ID; ?>);">
                <?php _e('Book Shipment'); ?></a>
            <div style="line-height:1.5em;">

                <label for="home_delivery" style="float:left; margin-left:5px">
                    <input data-pakketinput="1" type="checkbox" id="home_delivery"
                        name="home_delivery[<?php echo (int)$order->ID; ?>]" value="hjemlevering"/>
                    Hjemlevering / Pose på dør
                </label>

                <div style="line-height:1.5em;">




            </div>

            <div style="width:100%;">
            <style>
            .trackingTable th{
                padding:5px;
                background-color: lightgrey;
                border: 1px solid;
            }
            .trackingTable td {
                border:1px solid #ccc;
                padding:5px 10px;
                vertical-align:top;
                word-break:break-word;
            }
            .trackingTable tr {
                padding:5px;
                border: 1px solid;
            }

            table {
                border-collapse:collapse;
                table-layout:fixed;
            }
            </style>

            <?php

                $pakkepostOrderId = $order->get_meta( '_pakkepost_order_id', true );

                $pakkepost_user_id = get_option('pakkepost_user_id');
                $pakkepostSubscriptionKey = get_option('pakkepost_subscription_id');

                $api_mode = (get_option('api_mode') != '') ? get_option('api_mode') : 'Test';

                if ("Live" == $api_mode) {
                    $trackingURL = getValue('PAKKEPOST_TRACKING_URL_PROD');
                    $receiptURL = getValue('PAKKEPOST_RECEIPT_URL_PROD');
                } else {
                    $trackingURL = getValue('PAKKEPOST_TRACKING_URL_TEST');
                    $receiptURL = getValue('PAKKEPOST_RECEIPT_URL_TEST');
                }

                if ($pakkepostOrderId != null) {
                echo "<h4>Mine sendinger</h4>";
                    $curl = curl_init();
                    curl_setopt_array($curl, array(
                        CURLOPT_URL => $trackingURL.'?order_number='.$pakkepostOrderId,
                        CURLOPT_RETURNTRANSFER => true,
                        CURLOPT_ENCODING => '',
                        CURLOPT_MAXREDIRS => 10,
                        CURLOPT_TIMEOUT => 0,
                        CURLOPT_FOLLOWLOCATION => true,
                        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                        CURLOPT_CUSTOMREQUEST => 'GET',
                        CURLOPT_HTTPHEADER => array(
                            'Ocp-Apim-Subscription-Key: '. $pakkepostSubscriptionKey
                        ),
                    ));

                    $response = curl_exec($curl);
                    $data = json_decode($response);



                    curl_close($curl);
                    if ($data != null ) {
                        if (isset($data->data[0])) {
                            if ($data->data[0]->consignmentNumber != null) {
                                $packageNumber = $data->data[0]->packageNumber;
                                $tracking = $data->data[0]->tracking;
                                $receiverName = $data->data[0]->receiverName;
                                $creationDate = $data->data[0]->creationdate;
                                $label = $data->data[0]->label;                          

                                $curl = curl_init();
                                curl_setopt_array($curl, array(
                                    CURLOPT_URL => $receiptURL . '?userid=' . $pakkepost_user_id . '&order_number=' . $pakkepostOrderId,
                                    CURLOPT_RETURNTRANSFER => true,
                                    CURLOPT_ENCODING => '',
                                    CURLOPT_MAXREDIRS => 10,
                                    CURLOPT_TIMEOUT => 0,
                                    CURLOPT_FOLLOWLOCATION => true,
                                    CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
                                    CURLOPT_CUSTOMREQUEST => 'GET',
                                    CURLOPT_HTTPHEADER => array(
                                        'Ocp-Apim-Subscription-Key: ' . $pakkepostSubscriptionKey
                                    ),
                                ));

                                $responseInvoice = curl_exec($curl);
                                $receiptResponse = json_decode($responseInvoice);
                                curl_close($curl);
                                if ($receiptResponse !== null) {
                                    $receipt = $receiptResponse->data;
                                }

                                echo "<div id='panelBelow'><table class='trackingTable'>";
                                echo "<tr style='text-align: left; padding:10px;'>
                                    <th>ORDRE ID</th>
                                    <th>MOTTAKER</th>
                                    <th>PAKKENUMMER</th>
                                    <th>SPORING</th>
                                    <th>ETIKETT</th>
                                    <th>OPPRETTET</th>
                                    <th>KVITTERING</th>
                                </tr>";
                                echo "<tr>
                                    <td>" . $pakkepostOrderId . "</td>
                                    <td>" . $receiverName . "</td>
                                    <td>" . $packageNumber . "</td>
                                    <td><a href='$tracking'>Status</a></td>
                                    <td><a href='$label'> Last ned </a></td>
                                    <td>" . $creationDate . "</td>
                                    <td><a href='$receipt'>Last ned</a></td>
                                </tr>";
                                echo "</table></div>";
                            }
                        }
                    }
                }
                
                ?>

            </div>


            <div class="clear"></div>
        </div>

        <script type="text/javascript">
        function bookShipment(el, event, orderId) {
            var form = document.createElement("form");
            var orders = [];
            if ((typeof orderId === 'undefined') || (!orderId)) {
                jQuery('#the-list input[name="post[]"]').each(function () {
                    if (this.checked) {
                        orders.push(this.value);
                    }
                });
            } else {
                orders.push(orderId);
            }
            for (var i = 0; i < orders.length; i++) {

                var currentOrderId = orders[i];
                var shipType = document.createElement("input");
                shipType.type = 'hidden';
                shipType.name = 'shipping_type[' + currentOrderId + ']';
                var stEl = document.getElementsByName('shipping_type[' + currentOrderId + ']');
                if ((stEl) && (stEl.length >= 1)) {
                    shipType.value = jQuery(stEl[0]).val();
                    if (shipType.value == 0) {
                        return false;
                    }
                    form.appendChild(shipType);
                }
                var homeDelivery = document.createElement("input");
                homeDelivery.type = 'hidden';
                homeDelivery.name = 'home_delivery[' + currentOrderId + ']';
                var hdEl = document.getElementsByName('home_delivery[' + currentOrderId + ']');
                if ((hdEl) && (hdEl.length >= 1)) {
                    if (hdEl[0].checked) {
                        homeDelivery.value = 'hjemlevering';
                    } else {
                        homeDelivery.value = '';
                    }
                    form.appendChild(homeDelivery);
                }

                let numberOfPackagesElement = document.createElement("input");
                numberOfPackagesElement.type = 'hidden';
                numberOfPackagesElement.name = 'number_of_packages';
                let numberOfPackages = document.getElementsByName('number_of_packages');
                numberOfPackagesElement.value = jQuery(numberOfPackages[0]).val();
                form.appendChild(numberOfPackagesElement);

                var orderIdEl = document.createElement("input");
                orderIdEl.type = 'hidden';
                orderIdEl.name = 'order_id[' + currentOrderId + ']';
                orderIdEl.value = currentOrderId;
                form.appendChild(orderIdEl);
            }
            if (orders.length === 0) {
                return false;
            }
            var actionEl = document.createElement("input");
            actionEl.type = 'hidden';
            actionEl.name = 'action';
            actionEl.value = 'my_action_pakkepost';
            form.appendChild(actionEl);
            form.name = 'pakkepostform';
            form.method = "POST";
            form.action = el.href;
            document.body.appendChild(form);
            console.log(jQuery(form).serialize());
            form.submit();

            // Prevent the default form submission
            return false;

        }
        </script><?php
    }
}
?>